# IR2019
This is the course repository for the course Information Retrieval in the summer term 2019.

**`Please read this document carefully as it is the starting point for your practical exercises.`**

# Forking
*Note: You only need to do this once. After you have your fork, you will continue working on it during the semester.*

1. Please fork this project so you'll have your repository.
    [Click here to fork this project](https://git.uni-wuppertal.de/meuschke/ir2019/forks/new)
2. Set your fork to `Private` and grant the following people `Developer` access to the project:
    - Norman Meuschke (@meuschke)
    - Tomas Foltynek (@foltynek)

# Keep your project up to date!
We will continuously extend this project so you will have to update your forks. Git offers a convenient way to do so: `merging`:
## First time
You will have to add another remote repository which refers to this project.
```shell
git remote add -f exercise https://git.uni-wuppertal.de/meuschke/ir2019.git
```
Now you have two remote repositories. Your repository is called `origin`; the remote repository of the exercise is called `exercise`.

## Merging
You need to do this constantly to update and sync your project with our project. We will provide you with libraries and example code to help you with your assignments.
To merge our code into your project:
```shell
git fetch --all
git status
#SHOULD OUTPUT:
#On branch master
#Your branch is up to date with 'origin/master'.
#
#nothing to commit, working tree clean


git merge exercise/master
```
Of course, you may also use your favorite IDE/GUI tool to do this.
> Be advised that you should not switch branches to the exercise master branch. You will have no privileges to push onto this branch.

**`If you run into merge conflicts make sure you resolve them!`**


**`Pay attention to the due dates of the exercises!`**

1. Commit and push your changes and make sure your code is executable and understandable. *Add comments to your code to help us understand your programs!*
2. After the code is *committed and pushed* please `tag` your commit.
    - You can do this via gitlab:
        - Click on *Repository*
        - Click on *Tags* (just below, right side)
        - Add a new Tag and name it according to the Assignment, e.g., "Assignment 1"
    - You can also do this via the git command line:
        - `git tag -a A01-final -m 'Comment for Assignment 1 (optional)'`

> Note: Feel free to use other branches if you want to try out things; these branches will not be subject to grading.
> Only code committed to the master branch and tagged with the appropriate tag will be graded.

# Questions?
Please send us an e-mail: 
- Norman Meuschke <meuschke@uni-wuppertal.de>